package com.adventurer_engine.common.entity.ai.branch_nodes.control;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.adventurer_engine.common.entity.ai.AIObject;
import com.adventurer_engine.common.entity.ai.NodeBase;
import com.adventurer_engine.common.entity.ai.NodeStatus;
import com.adventurer_engine.common.entity.ai.branch_nodes.ControlNode;

public class ParallelNode extends ControlNode {
  private int finishAmount = 0;
  
  private int successAmount = 0;
  
  public static final String INTERNAL_NAME = "parallel";
  
  public ParallelNode(AIObject ai) {
    super(ai);
  }
  
  public NodeStatus onChildReportRUNNING() {
    return NodeStatus.RUNNING;
  }
  
  public NodeStatus onChildReportSUCCESS() {
    this.finishAmount++;
    this.successAmount++;
    if (this.finishAmount == this.child.size())
      return onAllFinished(); 
    return NodeStatus.RUNNING;
  }
  
  public NodeStatus onChildReportFAILURE() {
    this.finishAmount++;
    if (this.finishAmount == this.child.size())
      return onAllFinished(); 
    return null;
  }
  
  private NodeStatus onAllFinished() {
    if (this.successAmount == this.child.size())
      return NodeStatus.SUCCESS; 
    return NodeStatus.FAILURE;
  }
  
  public NodeStatus onParentSendInit() {
    if (this.child.isEmpty())
      return NodeStatus.SUCCESS; 
    for (int i = 0; i < this.child.size(); i++)
      executeChildNode(i); 
    return NodeStatus.RUNNING;
  }
  
  public void reset() {
    super.reset();
    this.finishAmount = 0;
    this.successAmount = 0;
  }
  
  public String internalName() {
    return "parallel";
  }
  
  public NodeBase copy(AIObject ai) {
    com.adventurer_engine.common.entity.ai.branch_nodes.control.ParallelNode node = new com.adventurer_engine.common.entity.ai.branch_nodes.control.ParallelNode(ai);
    node.child = copyChild(ai);
    return (NodeBase)node;
  }
}
